  MODULE mod_ioclient_para
    INTEGER,PARAMETER :: color_client=1
    INTEGER,PARAMETER :: color_server=2 
    INTEGER,SAVE      :: iocomm
    INTEGER,SAVE      :: iosize
    INTEGER,SAVE      :: iorank
    INTEGER,SAVE      :: server_rank
    INTEGER,SAVE      :: intracomm 
  CONTAINS
  
  
  SUBROUTINE Init_parallel
  USE mpitrace
  IMPLICIT NONE
    INCLUDE 'mpif.h'
    INTEGER :: NEW_COMM
    INTEGER :: ierr
    INTEGER :: global_rank
    INTEGER :: global_size
    INTEGER :: mpi_rank
    INTEGER :: mpi_size
    INTEGER :: nb_server_io  
    INTEGER,ALLOCATABLE :: proc_color(:) 
    INTEGER :: i
    INTEGER :: div,remain
    INTEGER :: group_color
    
!    PRINT *, "on rentre dans MPI_INIT"
    CALL MPI_INIT(ierr)
    CALL MPI_COMM_RANK(MPI_COMM_WORLD,global_rank,ierr)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD,global_size,ierr)
    
    PRINT *,"MPI_init Ok, --> mpi_comm_split"
    CALL MPI_COMM_SPLIT(MPI_COMM_WORLD,color_client,global_rank,intracomm,ierr)
    CALL MPI_COMM_SIZE(intracomm,mpi_size,ierr)
    CALL MPI_COMM_RANK(intracomm,mpi_rank,ierr)
    PRINT *,"MPI_mpi_comm_split ok --> intracomm" 
    nb_server_io=global_size-mpi_size
    div=mpi_size/nb_server_io
    remain=MOD(mpi_size,nb_server_io)
    
    IF (mpi_rank<remain*(div+1)) THEN
      group_color=mpi_rank/(div+1)
    ELSE
      group_color=(nb_server_io-1)-(mpi_size-1-mpi_rank)/div
    ENDIF
    PRINT *,'group_color',group_color

    CALL MPI_COMM_SPLIT(MPI_COMM_WORLD,group_color,global_rank,iocomm,ierr)
    
    CALL MPI_COMM_SIZE(iocomm,iosize,ierr)
    CALL MPI_COMM_RANK(iocomm,iorank,ierr)
    PRINT *,"io_size-> ",iosize,"iorank-> ",iorank
    ALLOCATE(proc_color(0:iosize-1))
    CALL MPI_ALLGATHER(color_client,1,MPI_INTEGER,proc_color,1,MPI_INTEGER,iocomm,ierr)
    print *,"proc_color -> ",proc_color
    
    DO i=0,iosize-1
      IF (proc_color(i)==color_server) THEN
        server_rank=i
        EXIT
      ENDIF
    ENDDO
    
    PRINT *,"Proces No",mpi_rank,"--> server",server_rank
  END SUBROUTINE Init_parallel
  
  SUBROUTINE Finalize_parallel
  IMPLICIT NONE
    include 'mpif.h'
    INTEGER :: ierr
    
    CALL MPI_FINALIZE(ierr)

  END SUBROUTINE Finalize_parallel
  
  END MODULE mod_ioclient_para
