  MODULE mod_ioserver_para
    INTEGER,PARAMETER :: color_client=1
    INTEGER,PARAMETER :: color_server=2 

    INTEGER,SAVE      :: iocomm
    INTEGER,SAVE      :: iosize
    INTEGER,SAVE      :: iorank
    
    INTEGER,SAVE      :: mpi_rank
    INTEGER,SAVE      :: mpi_size
    INTEGER,SAVE      :: mpi_master
    LOGICAL,SAVE      :: is_mpi_master
  
    INTEGER,SAVE      :: nb_client
    INTEGER,ALLOCATABLE,SAVE      :: client_rank(:)
    INTEGER,SAVE      :: intracomm 
  CONTAINS
  
  
  SUBROUTINE Init_parallel
  USE mpitrace
  IMPLICIT NONE
    INCLUDE 'mpif.h'
    INTEGER :: ierr
    INTEGER :: global_rank
    INTEGER :: global_size
    INTEGER,ALLOCATABLE :: proc_color(:)
    INTEGER :: i
    INTEGER :: group_color
    
    CALL MPI_INIT(ierr)
    CALL MPI_COMM_RANK(MPI_COMM_WORLD,global_rank,ierr)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD,global_size,ierr)
   
    CALL MPI_COMM_SPLIT(MPI_COMM_WORLD,color_server,global_rank,intracomm,ierr)
    CALL MPI_COMM_SIZE(intracomm,mpi_size,ierr)
    CALL MPI_COMM_RANK(intracomm,mpi_rank,ierr)
    
    group_color=mpi_rank
    PRINT *,'group_color',group_color

    CALL MPI_COMM_SPLIT(MPI_COMM_WORLD,group_color,global_rank,iocomm,ierr)    
    
    CALL MPI_COMM_SIZE(iocomm,iosize,ierr)
    CALL MPI_COMM_RANK(iocomm,iorank,ierr)

    PRINT *,"io_size-> ",iosize,"iorank-> ",iorank
    
    ALLOCATE(proc_color(0:iosize-1))
    CALL MPI_ALLGATHER(color_server,1,MPI_INTEGER,proc_color,1,MPI_INTEGER,iocomm,ierr)
    print *,"proc_color -> ",proc_color
    
    ALLOCATE(client_rank(iosize-1))
    nb_client=0
    DO i=0,iosize-1
      IF (proc_color(i)==color_client) THEN
        nb_client=nb_client+1
        client_rank(nb_client)=i
      ENDIF
    ENDDO

    PRINT *,"Proces No",mpi_rank,"--> client ",client_rank
  END SUBROUTINE Init_parallel
  
  SUBROUTINE Finalize_parallel
  IMPLICIT NONE
    include 'mpif.h'
    INTEGER :: ierr
    
    CALL MPI_FINALIZE(ierr)

  END SUBROUTINE Finalize_parallel

END MODULE mod_ioserver_para
