  MODULE mod_pack
    INTEGER,PARAMETER :: integer_size=4
    INTEGER,PARAMETER :: pack_buffer_max_size=integer_size*1024*1024
    INTEGER(kind=8),POINTER,SAVE      :: pack_buffer(:)
    INTEGER,SAVE      :: pack_pos
    
    INTERFACE pack
      MODULE PROCEDURE pack_r,pack_r1,pack_r2,pack_r3,pack_r4,                 &
                       pack_i,pack_i1,pack_i2,pack_i3,pack_i4,                 &
                       pack_l,pack_l1,pack_l2,pack_l3,pack_l4,                 &
                       pack_c,pack_c1,pack_c2,pack_c3,pack_c4
    END INTERFACE pack

    INTERFACE unpack
      MODULE PROCEDURE unpack_r,unpack_r1,unpack_r2,unpack_r3,unpack_r4,       &
                       unpack_i,unpack_i1,unpack_i2,unpack_i3,unpack_i4,       &
                       unpack_l,unpack_l1,unpack_l2,unpack_l3,unpack_l4,       &
                       unpack_c,unpack_c1,unpack_c2,unpack_c3,unpack_c4
    END INTERFACE unpack

    INTERFACE pack_field
      MODULE PROCEDURE pack_field1,pack_field2,pack_field3,pack_field4        
    END INTERFACE pack_field

    INTERFACE unpack_field
      MODULE PROCEDURE unpack_field1,unpack_field2,unpack_field3,unpack_field4 
    END INTERFACE unpack_field
           
  CONTAINS
  
    SUBROUTINE set_pack_buffer(pack_buffer0,pack_pos0)
    IMPLICIT NONE
    INTEGER(kind=8),POINTER  :: pack_buffer0(:)
    INTEGER                  :: pack_pos0
    
      pack_buffer=>pack_buffer0
      pack_pos=pack_pos0

    END SUBROUTINE set_pack_buffer
    
    
    SUBROUTINE pack_r(arg)
      IMPLICIT NONE
        REAL :: arg
         
        CALL packf_r(pack_buffer(pack_pos),pack_pos,arg,1)
     
     END SUBROUTINE pack_r
     
     SUBROUTINE pack_r1(arg)
      IMPLICIT NONE
        REAL :: arg(:)
        
        CALL packf_r(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_r1

    
     SUBROUTINE pack_r2(arg)
      IMPLICIT NONE
        REAL :: arg(:,:)
        
        CALL packf_r(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_r2
     
     
     SUBROUTINE pack_r3(arg)
      IMPLICIT NONE
        REAL :: arg(:,:,:)
        
        CALL packf_r(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_r3

     
     SUBROUTINE pack_r4(arg)
      IMPLICIT NONE
        REAL :: arg(:,:,:,:)
        
        CALL packf_r(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_r4


    SUBROUTINE unpack_r(arg)
      IMPLICIT NONE
        REAL :: arg
         
        CALL unpackf_r(pack_buffer(pack_pos),pack_pos,arg,1)
     
     END SUBROUTINE unpack_r
     
     SUBROUTINE unpack_r1(arg)
      IMPLICIT NONE
        REAL :: arg(:)
        
        CALL unpackf_r(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_r1

    
     SUBROUTINE unpack_r2(arg)
      IMPLICIT NONE
        REAL :: arg(:,:)
        
        CALL unpackf_r(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_r2
     
     
     SUBROUTINE unpack_r3(arg)
      IMPLICIT NONE
        REAL :: arg(:,:,:)
        
        CALL unpackf_r(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_r3

     
     SUBROUTINE unpack_r4(arg)
      IMPLICIT NONE
        REAL :: arg(:,:,:,:)
        
        CALL unpackf_r(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_r4




    SUBROUTINE pack_i(arg)
      IMPLICIT NONE
        INTEGER :: arg
         
        CALL packf_i(pack_buffer(pack_pos),pack_pos,arg,1)
     
     END SUBROUTINE pack_i
     
     SUBROUTINE pack_i1(arg)
      IMPLICIT NONE
        INTEGER :: arg(:)
        
        CALL packf_i(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_i1

    
     SUBROUTINE pack_i2(arg)
      IMPLICIT NONE
        INTEGER :: arg(:,:)
        
        CALL packf_i(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_i2
     
     
     SUBROUTINE pack_i3(arg)
      IMPLICIT NONE
        INTEGER :: arg(:,:,:)
        
        CALL packf_i(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_i3

     
     SUBROUTINE pack_i4(arg)
      IMPLICIT NONE
        INTEGER :: arg(:,:,:,:)
        
        CALL packf_i(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_i4
     

    SUBROUTINE unpack_i(arg)
      IMPLICIT NONE
        INTEGER :: arg
         
        CALL unpackf_i(pack_buffer(pack_pos),pack_pos,arg,1)
     
     END SUBROUTINE unpack_i
     
     SUBROUTINE unpack_i1(arg)
      IMPLICIT NONE
        INTEGER :: arg(:)
        
        CALL unpackf_i(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_i1

    
     SUBROUTINE unpack_i2(arg)
      IMPLICIT NONE
        INTEGER :: arg(:,:)
        
        CALL unpackf_i(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_i2
     
     
     SUBROUTINE unpack_i3(arg)
      IMPLICIT NONE
        INTEGER :: arg(:,:,:)
        
        CALL unpackf_i(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_i3

     
     SUBROUTINE unpack_i4(arg)
      IMPLICIT NONE
        INTEGER :: arg(:,:,:,:)
        
        CALL unpackf_i(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_i4     







    SUBROUTINE pack_l(arg)
      IMPLICIT NONE
        LOGICAL :: arg
         
        CALL packf_l(pack_buffer(pack_pos),pack_pos,arg,1)
     
     END SUBROUTINE pack_l
     
     SUBROUTINE pack_l1(arg)
      IMPLICIT NONE
        LOGICAL :: arg(:)
        
        CALL packf_l(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_l1

    
     SUBROUTINE pack_l2(arg)
      IMPLICIT NONE
        LOGICAL :: arg(:,:)
        
        CALL packf_l(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_l2
     
     
     SUBROUTINE pack_l3(arg)
      IMPLICIT NONE
        LOGICAL :: arg(:,:,:)
        
        CALL packf_l(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_l3

     
     SUBROUTINE pack_l4(arg)
      IMPLICIT NONE
        LOGICAL :: arg(:,:,:,:)
        
        CALL packf_l(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE pack_l4
     

    SUBROUTINE unpack_l(arg)
      IMPLICIT NONE
        LOGICAL :: arg
         
        CALL unpackf_l(pack_buffer(pack_pos),pack_pos,arg,1)
     
     END SUBROUTINE unpack_l
     
     SUBROUTINE unpack_l1(arg)
      IMPLICIT NONE
        LOGICAL :: arg(:)
        
        CALL unpackf_l(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_l1

    
     SUBROUTINE unpack_l2(arg)
      IMPLICIT NONE
        LOGICAL :: arg(:,:)
        
        CALL unpackf_l(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_l2
     
     
     SUBROUTINE unpack_l3(arg)
      IMPLICIT NONE
        LOGICAL :: arg(:,:,:)
        
        CALL unpackf_l(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_l3

     
     SUBROUTINE unpack_l4(arg)
      IMPLICIT NONE
        LOGICAL :: arg(:,:,:,:)
        
        CALL unpackf_l(pack_buffer(pack_pos),pack_pos,arg,size(arg))
        
     END SUBROUTINE unpack_l4     




   
     
   SUBROUTINE pack_c(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg
         
        CALL packf_c(pack_buffer(pack_pos),pack_pos,arg,len(arg))
     
     END SUBROUTINE pack_c
     
     SUBROUTINE pack_c1(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg(:)
        
        CALL packf_c(pack_buffer(pack_pos),pack_pos,arg,size(arg)*len(arg(1)))
        
     END SUBROUTINE pack_c1

    
     SUBROUTINE pack_c2(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg(:,:)
        
        CALL packf_c(pack_buffer(pack_pos),pack_pos,arg,size(arg)*len(arg(1,1)))
        
     END SUBROUTINE pack_c2
     
     
     SUBROUTINE pack_c3(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg(:,:,:)
        
        CALL packf_c(pack_buffer(pack_pos),pack_pos,arg,size(arg)*len(arg(1,1,1)))
        
     END SUBROUTINE pack_c3

     
     SUBROUTINE pack_c4(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg(:,:,:,:)
        
        CALL packf_c(pack_buffer(pack_pos),pack_pos,arg,size(arg)*len(arg(1,1,1,1)))
        
     END SUBROUTINE pack_c4
     

    SUBROUTINE unpack_c(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg
         
        CALL unpackf_c(pack_buffer(pack_pos),pack_pos,arg,len(arg))
     
     END SUBROUTINE unpack_c
     
     SUBROUTINE unpack_c1(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg(:)
        
        CALL unpackf_c(pack_buffer(pack_pos),pack_pos,arg,size(arg)*len(arg(1)))
        
     END SUBROUTINE unpack_c1

    
     SUBROUTINE unpack_c2(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg(:,:)
        
        CALL unpackf_c(pack_buffer(pack_pos),pack_pos,arg,size(arg)*len(arg(1,1)))
        
     END SUBROUTINE unpack_c2
     
     
     SUBROUTINE unpack_c3(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg(:,:,:)
        
        CALL unpackf_c(pack_buffer(pack_pos),pack_pos,arg,size(arg)*len(arg(1,1,1)))
        
     END SUBROUTINE unpack_c3

     
     SUBROUTINE unpack_c4(arg)
      IMPLICIT NONE
        CHARACTER(len=*) :: arg(:,:,:,:)
        
        CALL unpackf_c(pack_buffer(pack_pos),pack_pos,arg,size(arg)*len(arg(1,1,1,1)))
        
     END SUBROUTINE unpack_c4     
     




     SUBROUTINE pack_field1(arg)
     IMPLICIT NONE
       REAL :: arg(:)
     
       CALL packf_field(pack_buffer(pack_pos),pack_pos,arg,size(arg)) 
     END SUBROUTINE pack_field1


     SUBROUTINE pack_field2(arg)
     IMPLICIT NONE
       REAL :: arg(:,:)
       
       CALL packf_field(pack_buffer(pack_pos),pack_pos,arg,size(arg)) 
     END SUBROUTINE pack_field2
     
     SUBROUTINE pack_field3(arg)
     IMPLICIT NONE
       REAL :: arg(:,:,:)
     
       CALL packf_field(pack_buffer(pack_pos),pack_pos,arg,size(arg)) 
     END SUBROUTINE pack_field3

     SUBROUTINE pack_field4(arg)
     IMPLICIT NONE
       REAL :: arg(:,:,:,:)
     
       CALL packf_field(pack_buffer(pack_pos),pack_pos,arg,size(arg)) 
     END SUBROUTINE pack_field4



     SUBROUTINE unpack_field1(arg)
     IMPLICIT NONE
       REAL :: arg(:)
     
       CALL unpackf_field(pack_buffer(pack_pos),pack_pos,arg,size(arg)) 
     END SUBROUTINE unpack_field1


     SUBROUTINE unpack_field2(arg)
     IMPLICIT NONE
       REAL :: arg(:,:)
     
       CALL unpackf_field(pack_buffer(pack_pos),pack_pos,arg,size(arg)) 
     END SUBROUTINE unpack_field2
     
     SUBROUTINE unpack_field3(arg)
     IMPLICIT NONE
       REAL :: arg(:,:,:)
     
       CALL unpackf_field(pack_buffer(pack_pos),pack_pos,arg,size(arg)) 
     END SUBROUTINE unpack_field3

     SUBROUTINE unpack_field4(arg)
     IMPLICIT NONE
       REAL :: arg(:,:,:,:)
     
       CALL unpackf_field(pack_buffer(pack_pos),pack_pos,arg,size(arg)) 
     END SUBROUTINE unpack_field4
      
  END MODULE mod_pack
